import rwmidi.*; //RWMIDIライブラリの読み込み
MidiOutput output;
 
int ch = 0; //Midi Chの設定
int note = 60; //Noteナンバー（音階）の設定
int vel = 100;  //Velocity（音の強さ）の設定0〜127
int program = 1; //プログラムチェンジ（音色）の設定
int dev = 0; //音源の設定
int devLength = 0; //デバイスの数
 
void setup () {
  size (500, 300); //ウィンドウサイズ
  frameRate (30);
  devLength = RWMidi.getOutputDevices ().length; //デバイスの数
  output = RWMidi.getOutputDevices () [dev].createOutput(); //デバイスの設定
  output.sendProgramChange (program); //プログラムチェンジの設定
  //デバイスリストの表示
  for (int i = 0; i < devLength; i++) {
    println ("Output Device " + i + " : " +  RWMidi.getOutputDevices () [i].getName() );
  }
}
 
void draw () {
  background (0, 104, 55);
  text ("Device Name: " + output.getName (), 15, 20);
  text ("Program Change: " + program, 15, 40);
  text ("Click and release! ", 15, 80);
}
 
void mousePressed () {  //マウスを押した時
  output.sendNoteOn ( ch, note, vel );  //NoteOnの送信
  println ( "Ch: " + ch + "  Note: " + note + "  Vel: " + vel);  //Debug  
}
 
void mouseReleased () {  //マウスを離した時
  output.sendNoteOff(ch, note, vel);  //NoteOffの送信
}